
#include "newcodes.h"

// BE AWARE: ALL EMBEDDED ASM FUNCTION MUST HAVE 8 BYTE STACK ALIGMENT USAGE

/*
__asm void vEmbeddedAsmCode(void)
{
	// original code

	MOVS	R3, R6

	// new code
	PUSH	{R0-R6, LR}
	MOVS	R0, #0x12
	MOVS	R1, #0x34
	BL	__cpp(dwCFunction)
	POP	{R0-R6}
	POP	{R3}
	BX	R3
}
*/

u16 _swFullScreen[] = {'F', 'u', 'l', 'l', ' ', 'S', 'c', 'r', 'e', 'e', 'n', 0};
u16 _sw4_3[] = {'4', ':', '3', 0};
u16 _swNonAnam[] = {'N', 'o', 'n', ' ', 'A', 'n', 'a', 'm', 'o', 'r', 'p', 'h', 0};
u16 _sw16_9[] = {'1', '6', ':', '9', 0};
u16 _swAnam[] = {'A', 'n', 'a', 'm', 'o', 'r', 'p', 'h', 0};
u16 _sw185[] = {'1', '.', '8', '5', ':', '1', 0};
u16 _sw235[] = {'2', '.', '3', '5', ':', '1', 0};
u16 _sw237[] = {'2', '.', '3', '7', ':', '1', 0};
u16 _sw239[] = {'2', '.', '3', '9', ':', '1', 0};
u16 _sw276[] = {'2', '.', '7', '6', ':', '1', 0};

u32 _ppwDisplaySizeMsg[] = {   0,
                               0, //(u32)&_swFit,
                               0, //(u32)&_swOriginal,
                               0,
                               (u32)&_swFullScreen,
                               (u32)&_sw4_3,
                               (u32)&_swNonAnam,
                               (u32)&_sw16_9,
                               (u32)&_swAnam,
                               (u32)&_sw185,
                               (u32)&_sw235,
                               (u32)&_sw237,
                               (u32)&_sw239,
                               (u32)&_sw276,
                             };

u32 _pdwARnum[] = { 1, 1, 1, 1, 1, 4, 13672, 16, 1823, 185, 23529, 237, 239, 276 };
u32 _pdwARden[] = { 1, 1, 1, 1, 1, 3, 10000,  9, 1000, 100, 10000, 100, 100, 100 };

u32 pwGetToolItemTextPtr(u8 bDisplaySize)
{
	if (bDisplaySize < dsMAX)
	{
		if (bDisplaySize == dsFit)
		{
			return CResourceManager__GetWString(&g_ToolResMgr, OSD_MSG_TOOL_FIT);
		}
		else if (bDisplaySize == dsOriginal)
		{
			return CResourceManager__GetWString(&g_ToolResMgr, OSD_MSG_TOOL_ORIGINAL);
		}
		else
		{
			return _ppwDisplaySizeMsg[bDisplaySize];
		}
	}
	else
	{
		return 0;
	}
}

u8 bDisplaySizeItem_PressLeftRightKey(u8 bDisplaySize, u8 bKey)
{
	u8 bRet = bDisplaySize;

	if (bKey == 5) // Right arrow
	{
		bRet++;
		if (bRet == dsUnknown)
		{
			bRet = dsFullScreen;
		}
		else if (bRet >= dsMAX)
		{
			bRet = dsFit;
		}
	}
	else
	{
		if (bRet > dsFit)
		{
			bRet--;
			if (bRet == dsUnknown)
			{
				bRet = dsOriginal;
			}
		}
		else
		{
			bRet = dsMAX - 1;
		}
	}

	return bRet;
}

u32 dwCustomCalcDisplaySize(u8 bDisplaySize, u32 dwFrameWidth, u32 dwFrameHeight)
{
	u32 dwWidth, dwHeight, dwPanelWidth, dwPanelHeight, w, h;

#ifdef USE_ROSE_PRINT
	ROSE_PRINT(ROSE_MOVIE, ">>>> dwCustomCalcDisplaySize(%d, %d, %d)", bDisplaySize, dwFrameWidth, dwFrameHeight);
#endif

	if (CMovieCore__m_PanelResolution == 1)
	{
		dwPanelWidth = 1366;
		dwPanelHeight = 768;
	}
	else
	{
		dwPanelWidth = 1920;
		dwPanelHeight = 1080;
	}

#ifdef USE_ROSE_PRINT
	ROSE_PRINT(ROSE_MOVIE, "PANEL: %dx%d", dwPanelWidth, dwPanelHeight);
#endif

	switch (bDisplaySize)
	{
		case dsFit:
		case dsOriginal:
			dwWidth = dwFrameWidth;
			dwHeight = dwFrameHeight;
			break;

		case dsFullScreen:
			dwWidth = dwPanelWidth;
			dwHeight = dwPanelHeight;
			break;

		default:
			if ( (ds4_3 <= bDisplaySize) && (bDisplaySize <= ds276) )
			{
				dwWidth = dwFrameHeight * _pdwARnum[bDisplaySize] / _pdwARden[bDisplaySize];
				dwHeight = dwFrameHeight;
				// do a fit
				bDisplaySize = dsFit;
			}
			else
			{
				dwWidth = dwFrameWidth;
				dwHeight = dwFrameHeight;
			}
	}

#ifdef USE_ROSE_PRINT
	ROSE_PRINT(ROSE_MOVIE, "W x H = %d x %d", dwWidth, dwHeight);
#endif

	if (bDisplaySize == dsFit)
	{
#ifdef USE_ROSE_PRINT
		ROSE_PRINT(ROSE_MOVIE, "FIT...");
#endif
		// do a fit by keeping aspect ratio
		w = dwWidth;
		h = dwHeight;
		dwHeight = dwPanelWidth * h / w;
		if (dwHeight <= dwPanelHeight)
		{
			dwWidth = dwPanelWidth;
		}
		else
		{
			dwWidth = dwPanelHeight * w / h;
			dwHeight = dwPanelHeight;
		}
#ifdef USE_ROSE_PRINT
		ROSE_PRINT(ROSE_MOVIE, "W x H = %d x %d", dwWidth, dwHeight);
#endif
	}

	w = (dwWidth & 0xFFFF) | (dwHeight << 16);

#ifdef USE_ROSE_PRINT
	ROSE_PRINT(ROSE_MOVIE, "<<<< 0x%x <<<<", w);
#endif

	return w;
}
